/*
 * main.cpp
 *
 *  Created on: Feb 9, 2020
 *      Author: ayoungblood
 */

#include "Game.hpp"
#include "../cjson/cJSON.h"
#include <string>
#include <iostream>
#include <fstream>
#include <sstream>
#include <emscripten.h>

Game *game = nullptr;

struct context{
	const int FPS = 60;
	const int frameDelay = 1000 / FPS;

	Uint64 frameStart;
	int frameTime;
    std::string configPath = "src/config/config.json";
    std::ifstream fin(configPath);
    // if(!fin.is_open()){
    //     std::cout << "Failed to load Config.json" << std::endl;
    // } else {
        std::ifstream jsonText("src/config/config.json");
        std::ostringstream tmp;
        tmp << jsonText.rdbuf();
        std::string json = tmp.str();
        cJSON * myJSON = cJSON_Parse(json.c_str());
        cJSON * windowName = cJSON_GetObjectItemCaseSensitive(myJSON, "WindowName");
        cJSON * windowSize = cJSON_GetObjectItem(myJSON, "WindowSize");
        int windowWidth = cJSON_GetObjectItem(windowSize, "w")->valueint;
        int windowHeight = cJSON_GetObjectItem(windowSize, "h")->valueint;
        int windowFS = cJSON_GetObjectItem(myJSON, "WindowFullScreen")->valueint;
        int globalScale = cJSON_GetObjectItem(myJSON, "GlobalScale")->valueint;
        bool isWindowFS;
        if (windowFS==0)
        {
        	isWindowFS = false;
        } else
        {
        	isWindowFS = true;
        }

    // }
};


int main(int argc, const char * argv[])
{
    context ctx;
    if(ctx.fin.is_open()){

	game = new Game();
    ctx.windowWidth = ctx.windowWidth*ctx.globalScale;
    ctx.windowHeight = ctx.windowHeight*ctx.globalScale;
	game->init(ctx.windowName->valuestring, ctx.windowWidth, ctx.windowHeight, ctx.isWindowFS, ctx.globalScale);
//	cJSON memory management
    cJSON_Delete(ctx.myJSON);

    init(&ctx);

	while (game->running())
	{
		ctx.frameStart = SDL_GetTicks64();

		game->handleEvents();
		game->update();
		game->render();

		ctx.frameTime = SDL_GetTicks64() - ctx.frameStart;

		if(ctx.frameDelay > ctx.frameTime)
		{
			SDL_Delay(ctx.frameDelay - ctx.frameTime);
		}

	}
	game->clean();
    } else {
        std::cout<<"config.json not found or opened"<<std::endl;
    }
    
    if(ctx.fin.fail()){
        std::cout<<"config.json load failed"<<std::endl;
    } 
        
	return 0;
}
